<?php
/**
*
* @package acp
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_kb_categories
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		$this->tpl_name = 'acp_kb_categories';
		$this->page_title = 'ACP_MANAGE_KB_CATEGORIES';

		$form_key = 'acp_kb_categories';
		add_form_key($form_key);

		$action			= request_var('action', '');
		$category_id	= request_var('c', 0);
		$category_name	= request_var('category_name', '', true);

		$category_data = array();

		switch ($action)
		{
			case 'edit':
			case 'delete':
			case 'add':

				if (!$auth->acl_get('a_kb_manage'))
				{
					trigger_error($user->lang['NOT_AUTHORISED'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

			break;
		}

		switch ($action)
		{
			case 'add':
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . KB_CATEGORIES_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$category_data += array(
					'category_name'	=> utf8_normalize_nfc(request_var('category_name', '', true)),
					'left_id'		=> $row['right_id'] + 1,
					'right_id'		=> $row['right_id'] + 2,
				);

				$sql = 'INSERT INTO ' . KB_CATEGORIES_TABLE . ' ' . $db->sql_build_array('INSERT', $category_data);
				$db->sql_query($sql);

				//$category_data['category_id'] = $db->sql_nextid();

				add_log('admin', 'LOG_CATEGORY_ADD', $category_data['category_name']);

				trigger_error($user->lang['CATEGORY_CREATED'] . adm_back_link($this->u_action));
			break;

			case 'edit':
				if (!$category_id)
				{
					trigger_error($user->lang['NO_CATEGORY'] . adm_back_link($this->u_action));
				}

				$sql = 'SELECT *
					FROM ' . KB_CATEGORIES_TABLE . '
					WHERE category_id = ' . (int) $category_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					trigger_error("Category #$category_id does not exist", E_USER_ERROR);
				}

				$submit = (isset($_POST['submit'])) ? true : false;

				if ($submit)
				{
					$sql = 'UPDATE ' . KB_CATEGORIES_TABLE . '
						SET category_name = "' . $category_name . '"
						WHERE category_id = ' . (int) $category_id;
					$db->sql_query($sql);

					add_log('admin', 'LOG_CATEGORY_EDIT', $row['category_name']);

					trigger_error($user->lang['CATEGORY_UPDATED'] . adm_back_link($this->u_action));
				}

				$template->assign_vars(array(
					'CATEGORY_NAME'	=> $row['category_name'],

					'S_CATEGORY_EDIT'	=> true,

					'U_EDIT_CATEGORY'	=> $this->u_action . '&amp;action=edit&amp;c=' . $category_id,
				));
			break;

			case 'delete':
				if (!$category_id)
				{
					trigger_error($user->lang['NO_CATEGORY'] . adm_back_link($this->u_action));
				}

				$sql = 'SELECT COUNT(article_id) as articles
					FROM ' . KB_ARTICLES_TABLE . '
					WHERE category_id = ' . (int) $category_id;
				$db->sql_query($sql);
				$articles = $db->sql_fetchfield('articles');

				$sql = 'SELECT *
					FROM ' . KB_CATEGORIES_TABLE . '
					WHERE category_id = ' . (int) $category_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if ($articles == 0)
				{
					if (confirm_box(true))
					{
						$sql = 'DELETE FROM ' . KB_CATEGORIES_TABLE . '
							WHERE category_id = ' . (int) $category_id;
						$db->sql_query($sql);

						add_log('admin', 'LOG_CATEGORY_DEL_CATEGORY', $row['category_name']);

						trigger_error($user->lang['CATEGORY_DELETED'] . adm_back_link($this->u_action));
					}
					else
					{
						confirm_box(false, $user->lang['DELETE_CATEGORY_CONFIRM']);
					}
				}
				else
				{
					$delete_articles = request_var('delete_articles', 0);
					$move_to_category = request_var('move_to_category', 0);
					$submit = (isset($_POST['submit'])) ? true : false;

					if ($submit)
					{
						if ($delete_articles || !$move_to_category)
						{
							$sql = 'SELECT article_id
								FROM ' . KB_ARTICLES_TABLE . '
								WHERE category_id = ' . (int) $category_id;
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								$sql = 'DELETE FROM ' . KB_ARTICLES_TABLE . '
									WHERE article_id = ' . $row['article_id'];
								$db->sql_query($sql);
							}

							$sql = 'DELETE FROM ' . KB_CATEGORIES_TABLE . '
								WHERE category_id = ' . (int) $category_id;
							$db->sql_query($sql);
						}
						else if ($move_to_category)
						{
							$sql = 'UPDATE  ' . KB_ARTICLES_TABLE . '
								SET category_id = ' . $move_to_category . '
								WHERE category_id = ' . (int) $category_id;
							$db->sql_query($sql);

							$sql = 'DELETE FROM ' . KB_CATEGORIES_TABLE . '
								WHERE category_id = ' . (int) $category_id;
							$db->sql_query($sql);
						}

						add_log('admin', 'LOG_CATEGORY_DEL_CATEGORY', $row['category_name']);

						trigger_error($user->lang['CATEGORY_DELETED'] . adm_back_link($this->u_action));
					}

					$template->assign_vars(array(
						'DELETE_CATEGORY_ID'	=> $category_id,

						'S_CATEGORY_DELETE'	=> true,

						'U_DELETE_CATEGORY'	=> $this->u_action . '&amp;action=delete&amp;c=' . $category_id,
					));
				}
			break;

			case 'move_up':
			case 'move_down':
				if (!$category_id)
				{
					trigger_error($user->lang['NO_CATEGORY'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				$sql = 'SELECT *
					FROM ' . KB_CATEGORIES_TABLE . '
					WHERE category_id = ' . (int) $category_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					trigger_error($user->lang['NO_CATEGORY'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				$move_category = $this->move_category_by($row, $action, 1);

				if ($move_category !== false)
				{
					add_log('admin', 'LOG_CATEGORY_' . strtoupper($action), $row['category_name'], $move_category);
					$cache->destroy('sql', KB_CATEGORIES_TABLE);
				}
			break;
		}

		$sql = 'SELECT *
			FROM ' . KB_CATEGORIES_TABLE . "
			ORDER BY left_id";
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$template->assign_block_vars('categories', array(
				'CATEGORY_ID'		=> $row['category_id'],
				'CATEGORY_NAME'		=> $row['category_name'],

				'U_MOVE_UP'			=> $this->u_action . '&amp;action=move_up&amp;c=' . $row['category_id'],
				'U_MOVE_DOWN'		=> $this->u_action . '&amp;action=move_down&amp;c=' . $row['category_id'],
				'U_EDIT'			=> $this->u_action . '&amp;action=edit&amp;c=' . $row['category_id'],
				'U_DELETE'			=> $this->u_action . '&amp;action=delete&amp;c=' . $row['category_id'],
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'U_ADD_CATEGORY'	=>$this->u_action . '&amp;action=add',
		));
	}


	function move_category_by($category_row, $action = 'move_up', $steps = 1)
	{
		global $db;

		/**
		* Fetch all the siblings between the module's current spot
		* and where we want to move it to. If there are less than $steps
		* siblings between the current spot and the target then the
		* module will move as far as possible
		*/
		$sql = 'SELECT *
			FROM ' . KB_CATEGORIES_TABLE . '
			WHERE ' . (($action == 'move_up') ? "right_id < {$category_row['right_id']} ORDER BY right_id DESC" : "left_id > {$category_row['left_id']} ORDER BY left_id ASC");
		$result = $db->sql_query_limit($sql, 1);

		$target = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$target = $row;
		}
		$db->sql_freeresult($result);

		if (!sizeof($target))
		{
			// The category is already on top or bottom
			return false;
		}

		/**
		* $left_id and $right_id define the scope of the nodes that are affected by the move.
		* $diff_up and $diff_down are the values to substract or add to each node's left_id
		* and right_id in order to move them up or down.
		* $move_up_left and $move_up_right define the scope of the nodes that are moving
		* up. Other nodes in the scope of ($left_id, $right_id) are considered to move down.
		*/
		if ($action == 'move_up')
		{
			$left_id = $target['left_id'];
			$right_id = $category_row['right_id'];

			$diff_up = $category_row['left_id'] - $target['left_id'];
			$diff_down = $category_row['right_id'] + 1 - $category_row['left_id'];

			$move_up_left = $category_row['left_id'];
			$move_up_right = $category_row['right_id'];
		}
		else
		{
			$left_id = $category_row['left_id'];
			$right_id = $target['right_id'];

			$diff_up = $category_row['right_id'] + 1 - $category_row['left_id'];
			$diff_down = $target['right_id'] - $category_row['right_id'];

			$move_up_left = $category_row['right_id'] + 1;
			$move_up_right = $target['right_id'];
		}

		// Now do the dirty job
		$sql = 'UPDATE ' . KB_CATEGORIES_TABLE . "
			SET left_id = left_id + CASE
				WHEN left_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			right_id = right_id + CASE
				WHEN right_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END
			WHERE
				left_id BETWEEN {$left_id} AND {$right_id}
				AND right_id BETWEEN {$left_id} AND {$right_id}";
		$db->sql_query($sql);

		return $target['category_name'];
	}
}

?>