<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* hook class
* @package phpBB3
*/
abstract class hook_kb
{
	static public function register(&$phpbb_hook)
	{
		$phpbb_hook->register('phpbb_user_session_handler', 'hook_kb::init');
	}

	static public function init(&$hook)
	{
		global $auth, $config, $db, $table_prefix, $template, $user;
		global $phpbb_root_path, $phpEx;

		if ($user->page['page_name'] != 'install.' . $phpEx)
		{
			define('KB_CATEGORIES_TABLE', $table_prefix . 'kb_categories');
			define('KB_ARTICLES_TABLE', $table_prefix . 'kb_articles');

			$sql = 'SELECT article_id
				FROM ' . KB_ARTICLES_TABLE . '
				WHERE article_approved = 0
					AND article_denied = 0';
			$result = $db->sql_query($sql);
			$articles = array();
			while ($row = $db->sql_fetchrow($result))
			{
				$articles[] = $row['article_id'];
			}
			$db->sql_freeresult($result);

			$template->assign_vars(array(
				'ARTICLES' => ($auth->acl_get('m_kb_approve') || $auth->acl_get('m_kb_deny')) ? count($articles) : '',
			));
		}

		$user->add_lang('mods/kb');
		
		$template->assign_vars(array(
			'U_KB' => append_sid("{$phpbb_root_path}kb/index.$phpEx"),
		));
	}
}

hook_kb::register($phpbb_hook);
