<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="https://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the MOD to be displayed during installation.
$mod_name = 'phpBB Knowledge Base';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'phpbb_knowledge_base_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the MOD's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
//$language_file = 'mods/umil_auto_example';

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering. Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'1.0.1' => array(
		// Nothing changed in this version
	),

	'1.0.0' => array(
		'cache_purge' => array(
			'imageset',
			'template',
			'theme',
			'cache',
		),
	),

	'0.1.1' => array(
		// Nothing changed in this version
	),

	'0.1.0' => array(
		// Nothing changed in this version
	),
	
	'0.0.1' => array(
		'permission_add' => array(
			array('u_kb_delete', 1),
			array('u_kb_edit', 1),
			array('u_kb_post', 1),
			array('m_kb_approve', 1),
			array('m_kb_delete', 1),
			array('m_kb_deny', 1),
			array('m_kb_disapprove', 1),
			array('m_kb_edit', 1),
			array('a_kb_manage', 1),
		),

		'table_add' => array(
			array('phpbb_kb_articles', array(
				'COLUMNS' => array(
					'article_id' => array('UINT', NULL, 'auto_increment'),
					'category_id' => array('UINT', 0),
					'article_approved' => array('BOOL', 1),
					'article_denied' => array('BOOL', 0),
					'article_title' => array('VCHAR', ''),
					'article_description' => array('VCHAR', ''),
					'poster_id' => array('UINT', 0),
					'article_time' => array('TIMESTAMP', 0),
					'enable_bbcode' => array('BOOL', 1),
					'enable_smilies' => array('BOOL', 1),
					'enable_magic_url' => array('BOOL', 1),
					'message' => array('MTEXT', ''),
					'bbcode_bitfield' => array('VCHAR', ''),
					'bbcode_uid' => array('VCHAR:8', ''),
				),

				'PRIMARY_KEY' => 'article_id',
			)),

			array('phpbb_kb_categories', array(
				'COLUMNS' => array(
					'category_id' => array('UINT', NULL, 'auto_increment'),
					'left_id' => array('UINT', 0),
					'right_id' => array('UINT', 0),
					'category_name' => array('VCHAR', ''),
				),

				'PRIMARY_KEY' => 'category_id',
			)),
		),

		'module_add' => array(
			array('acp', 0, 'ACP_KB_CATEGORY_MANAGEMENT'),
			array('acp', 'ACP_KB_CATEGORY_MANAGEMENT', 'ACP_MANAGE_KB_CATEGORIES'),
			array('acp', 'ACP_MANAGE_KB_CATEGORIES', array(
				'module_basename' => 'kb_categories',
				'modes' => array('manage'),
			)),
		),
	),
);

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);