<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

$category_id = request_var('c', 'all');
$type = request_var('type', 'approved');

$sql = 'SELECT *
	FROM ' . KB_CATEGORIES_TABLE . '
	ORDER BY left_id ASC';
$result = $db->sql_query($sql);
$category_id_array = array();
while ($row = $db->sql_fetchrow($result))
{
	$category_id_array[] = $row['category_id'];

	$template->assign_block_vars('categories', array(
		'CATEGORY_ID'	=> $row['category_id'],
		'CATEGORY_NAME'	=> $row['category_name'],
		'SELECTED'		=> ($row['category_id'] == $category_id) ? ' selected="selected"' : '',
	));
}
$db->sql_freeresult($result);

if (!in_array($category_id, $category_id_array) && $category_id != 'all')
{
	trigger_error('NO_CATEGORY');
}

$type_select = ($type == 'approved') ? '<option value="approved" selected="selected">' . $user->lang['APPROVED'] . '</option>' : '<option value="approved">' . $user->lang['APPROVED'] . '</option>';
$type_select .= ($auth->acl_get('m_kb_approve') || $auth->acl_get('m_kb_deny')) ? (($type == 'disapproved') ? '<option value="disapproved" selected="selected">' . $user->lang['DISAPPROVED'] . '</option>' : '<option value="disapproved">' . $user->lang['DISAPPROVED'] . '</option>') : '';
$type_select .= ($auth->acl_get('m_kb_approve') || $auth->acl_get('m_kb_disapprove')) ? (($type == 'denied') ? '<option value="denied" selected="selected">' . $user->lang['DENIED'] . '</option>' : '<option value="denied">' . $user->lang['DENIED'] . '</option>') : '';

$sql_where = '';
if (($auth->acl_get('m_kb_approve') || $auth->acl_get('m_kb_deny') || $auth->acl_get('m_kb_disapprove')) && $type)
{
	switch ($type)
	{
		case 'approved':
			$sql_where .= ' AND article_approved = 1';
		break;

		case 'disapproved':
			$sql_where .= ' AND article_approved = 0 AND article_denied = 0';
		break;

		case 'denied':
			$sql_where .= ' AND article_approved = 0 AND article_denied = 1';
		break;
	}
}
else
{
	$sql_where .= ' AND article_approved = 1';
}

if ((!$auth->acl_get('m_kb_approve') && !$auth->acl_get('m_kb_deny') && !$auth->acl_get('m_kb_disapprove')) && $type != 'approved')
{
	trigger_error('NOT_AUTHORISED');
}

$sql_where .= ($category_id != 'all') ? ' AND a.category_id = ' . (int) $category_id : '';

$sql = 'SELECT a.*, c.*, u.user_id, u.user_colour, u.username
	FROM ' . KB_ARTICLES_TABLE . ' a, ' . KB_CATEGORIES_TABLE . ' c, ' . USERS_TABLE . " u
	WHERE u.user_id = a.poster_id
		AND a.category_id = c.category_id
		$sql_where";
$result = $db->sql_query($sql);
while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('article_row', array(
		'ARTICLE_TITLE'			=> $row['article_title'],
		'ARTICLE_DESCRIPTION'	=> $row['article_description'],
		'ARTICLE_POSTER'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
		'ARTICLE_CATEGORY'		=> $row['category_name'],
		'ARTICLE_TIME'			=> $user->format_date($row['article_time']),

		'U_VIEW_ARTICLE'	=> append_sid("{$phpbb_root_path}kb/viewarticle.$phpEx", 'a=' . $row['article_id']),
	));
}
$db->sql_freeresult($result);

$template->assign_vars(array(
	'S_ARTICLE_TYPE'	=> $type,
	'S_TYPE_SELECT'		=> ($type_select != '') ? '<select name="type" id="type" onchange="document.getElementById(\'type_select\').submit()">' . $type_select . '</select>' : '',

	'U_POST_NEW_ARTICLE'	=> ($auth->acl_get('u_kb_post')) ? append_sid("{$phpbb_root_path}kb/posting.$phpEx", 'mode=post') : '',
));

$template->assign_block_vars('navlinks', array(
	'FORUM_NAME' => $user->lang['KNOWLEDGE_BASE'],
	'U_VIEW_FORUM' => append_sid("{$phpbb_root_path}kb/index.$phpEx"),
));

page_header($user->lang['KNOWLEDGE_BASE']);

$template->set_filenames(array(
	'body' => 'kb/index_body.html')
);

page_footer();

?>