<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_kb.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mcp');

$article_id = request_var('a', 0);
$mode = request_var('mode', '');
$type = $mode == 'deny' ? $user->lang['DENIED'] : $user->lang[strtoupper($mode) . 'D'];

$submit = (isset($_POST['post'])) ? true : false;
$cancel = (isset($_POST['cancel'])) ? true : false;

if (!in_array($mode, array('approve', 'delete', 'deny', 'disapprove')))
{
	trigger_error('NO_MODE');
}

if (!$article_id)
{
	trigger_error('NO_ARTICLE');
}

$sql = 'SELECT *
	FROM ' . KB_ARTICLES_TABLE . '
	WHERE article_id = ' . (int) $article_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if (!$row)
{
	trigger_error('NO_ARTICLE');
}

if ($cancel)
{
	$redirect = append_sid("{$phpbb_root_path}kb/viewarticle.$phpEx", 'a=' . $article_id);
	redirect($redirect);
}

$notes = utf8_normalize_nfc(request_var('notes', '', true));

if ($submit)
{
	if ($notes === '')
	{
		$notes = 'none';
	}

	switch ($mode)
	{
		case 'approve':
			if (!$auth->acl_get('m_kb_approve') || $row['article_approved'])
			{
				trigger_error('NOT_AUTHORISED');
			}

			$data = array(
				'article_approved' => true,
				'article_denied' => false, // Make sure the article is not denied just to be safe
			);

			$sql = 'UPDATE ' . KB_ARTICLES_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . ' WHERE article_id = ' . (int) $article_id;
			$db->sql_query($sql);
			kb_send_pm(sprintf($user->lang['PM_SUBJECT'], $row['article_title']), sprintf($user->lang['PM_MESSAGE'], '<span style="color: #00AA00;">' . $type . '</span>', $notes));

			$meta_info = append_sid("{$phpbb_root_path}kb/viewarticle.{$phpEx}", 'a=' . (int) $article_id);

			meta_refresh(3, $meta_info);

			$message = $user->lang['ARTICLE_APPROVED_SUCCESS'];

			trigger_error($message);
		break;

		case 'delete':
			if (!$auth->acl_get('m_kb_delete'))
			{
				trigger_error('NOT_AUTHORISED');
			}

			$sql = 'DELETE FROM ' . KB_ARTICLES_TABLE . '
				WHERE article_id = ' . (int) $article_id;
			$db->sql_query($sql);
			kb_send_pm(sprintf($user->lang['PM_SUBJECT'], $row['article_title']), sprintf($user->lang['PM_MESSAGE'], '<span style="color: #00AA00;">' . $type . '</span>', $notes));

			$meta_info = append_sid("{$phpbb_root_path}kb/index.{$phpEx}");

			meta_refresh(3, $meta_info);

			$message = $user->lang['ARTICLE_DELETED_SUCCESS'];

			trigger_error($message);
		break;

		case 'deny':
			if (!$auth->acl_get('m_kb_deny') || $row['article_denied'])
			{
				trigger_error('NOT_AUTHORISED');
			}

			$data = array(
				'article_approved' => false, // Set the approval state to false - denied articles are not approved
				'article_denied' => true,
			);

			$sql = 'UPDATE ' . KB_ARTICLES_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . ' WHERE article_id = ' . (int) $article_id;
			$db->sql_query($sql);
			kb_send_pm(sprintf($user->lang['PM_SUBJECT'], $row['article_title']), sprintf($user->lang['PM_MESSAGE'], '<span style="color: #00AA00;">' . $type . '</span>', $notes));

			$meta_info = append_sid("{$phpbb_root_path}kb/viewarticle.{$phpEx}", 'a=' . (int) $article_id);

			meta_refresh(3, $meta_info);

			$message = $user->lang['ARTICLE_DENIED_SUCCESS'];

			trigger_error($message);
		break;

		case 'disapprove':
			if (!$auth->acl_get('m_kb_disapprove') || (!$row['article_approved'] && !$row['article_denied']))
			{
				trigger_error('NOT_AUTHORISED');
			}

			$data = array(
				'article_approved' => false,
				'article_denied' => false,
			);

			$sql = 'UPDATE ' . KB_ARTICLES_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . ' WHERE article_id = ' . (int) $article_id;
			$db->sql_query($sql);
			kb_send_pm(sprintf($user->lang['PM_SUBJECT'], $row['article_title']), sprintf($user->lang['PM_MESSAGE'], '<span style="color: #00AA00;">' . $type . '</span>', $notes));

			$meta_info = append_sid("{$phpbb_root_path}kb/viewarticle.{$phpEx}", 'a=' . (int) $article_id);

			meta_refresh(3, $meta_info);

			$message = $user->lang['ARTICLE_DISAPPROVED_SUCCESS'];

			trigger_error($message);
		break;
	}
}

page_header($user->lang['KNOWLEDGE_BASE']);

$template->set_filenames(array(
	'body' => 'kb/mcp_body.html')
);

page_footer();

?>