<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mcp');

$article_id = request_var('a', 0);

if (!$article_id)
{
	trigger_error('NO_ARTICLE');
}

$sql_where = '';
$sql_where .= (!$auth->acl_get('m_kb_approve')) ? ' AND article_approved = 1' : '';

$sql = 'SELECT a.*, c.*, u.user_id, u.user_colour, u.username
	FROM ' . KB_ARTICLES_TABLE . ' a, ' . KB_CATEGORIES_TABLE . ' c, ' . USERS_TABLE . ' u
	WHERE u.user_id = a.poster_id
		AND a.article_id = ' . (int) $article_id . "
		AND a.category_id = c.category_id
		$sql_where";
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if (!$row)
{
	trigger_error('NO_ARTICLE');
}

$row['bbcode_options'] = (($row['enable_bbcode']) ? OPTION_FLAG_BBCODE : 0) +
	(($row['enable_smilies']) ? OPTION_FLAG_SMILIES : 0) +
	(($row['enable_magic_url']) ? OPTION_FLAG_LINKS : 0);
$text = generate_text_for_display($row['message'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);

$board_url = generate_board_url();

$template->assign_vars(array(
	'ARTICLE_URL'			=> append_sid($board_url . "/kb/viewarticle.$phpEx", 'a=' . $row['article_id']),
	'ARTICLE_TITLE'			=> $row['article_title'],
	'ARTICLE_DESCRIPTION'	=> $row['article_description'],
	'ARTICLE_POSTER'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
	'ARTICLE_CATEGORY'		=> $row['category_name'],
	'ARTICLE_TIME'			=> $user->format_date($row['article_time']),
	'MESSAGE'				=> $text,

	'S_DENIED'	=> $row['article_denied'] ? true : false,

	'U_APPROVE'		=> $auth->acl_get('m_kb_approve') ? ($row['article_approved'] ? '' : append_sid("{$phpbb_root_path}kb/mcp.$phpEx", 'mode=approve&amp;a=' . $row['article_id'])) : '',
	'U_DELETE'		=> ($auth->acl_get('u_kb_delete') && $user->data['user_id'] == $row['poster_id']) ? append_sid("{$phpbb_root_path}kb/posting.$phpEx", 'mode=delete&amp;a=' . $row['article_id']) : ($auth->acl_get('m_kb_delete') ? append_sid("{$phpbb_root_path}kb/mcp.$phpEx", 'mode=delete&amp;a=' . $row['article_id']) : ''),
	'U_DENY'		=> $auth->acl_get('m_kb_deny') ? ($row['article_denied'] ? '' : append_sid("{$phpbb_root_path}kb/mcp.$phpEx", 'mode=deny&amp;a=' . $row['article_id'])) : '',
	'U_DISAPPROVE'	=> $auth->acl_get('m_kb_disapprove') ? ($row['article_approved'] || $row['article_denied'] ? append_sid("{$phpbb_root_path}kb/mcp.$phpEx", 'mode=disapprove&amp;a=' . $row['article_id']) : '') : '',
	'U_EDIT'		=> ($auth->acl_get('m_kb_edit') || ($auth->acl_get('u_kb_edit') && $user->data['user_id'] == $row['poster_id'])) ? append_sid("{$phpbb_root_path}kb/posting.$phpEx", 'mode=edit&amp;a=' . $row['article_id']) : '',
));

$navlinks_array = array(
	array(
		'FORUM_NAME' => $user->lang['KNOWLEDGE_BASE'],
		'U_VIEW_FORUM' => append_sid("{$phpbb_root_path}kb/index.$phpEx"),
	),

	array(
		'FORUM_NAME' => $row['article_title'],
		'U_VIEW_FORUM' => append_sid("{$phpbb_root_path}kb/viewarticle.$phpEx", 'a=' . $row['article_id']),
	),
);

foreach ($navlinks_array as $name)
{
	$template->assign_block_vars('navlinks', array(
		'FORUM_NAME' => $name['FORUM_NAME'],
		'U_VIEW_FORUM' => $name['U_VIEW_FORUM'],
	));
}

page_header($user->lang['KNOWLEDGE_BASE'] . ' - ' . $row['article_title']);

$template->set_filenames(array(
	'body' => 'kb/viewarticle_body.html')
);

page_footer();

?>